/* $Copyright:	$
 * Copyright (c) 1984, 1985, 1986, 1987, 1988, 1989, 1990 
 * Sequent Computer Systems, Inc.   All rights reserved.
 *  
 * This software is furnished under a license and may be used
 * only in accordance with the terms of that license and with the
 * inclusion of the above copyright notice.   This software may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
*/

/*	Copyright (c) 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

#ident	"$Header: ungetwch.c 1.3 90/10/30 $@(#)curses:screen/ungetwch.c 1.0 AT&T-UP"

#include	"curses_inc.h"


/*
**	Push a process code back into the input stream
*/
ungetwch(code)
wchar_t	code;
	{
	int	i, n;
	unsigned char	buf[CSMAX];

	n = wctomb(buf, code & TRIM);
	for(i = n-1; i >= 0; --i)
		if(ungetch(buf[i]) == ERR)
		{
		/* remove inserted characters */
		for(i = i+1; i < n; ++i)
			tgetch(0);
		return ERR;
		}

	return OK;
	}
